diff --git a/platform/linux-generic/include/api/odp_packet.h b/platform/linux-generic/include/api/odp_packet.h
index 97c2cb6..d0f15ac 100644
--- a/platform/linux-generic/include/api/odp_packet.h
+++ b/platform/linux-generic/include/api/odp_packet.h
@@ -469,6 +469,7 @@ void *odp_packet_l2_ptr(odp_packet_t pkt, uint32_t *len);
  * @param pkt  Packet handle
  *
  * @return  Layer 2 start offset
+ * @retval  ODP_PACKET_OFFSET_INVALID  If not found
  */
 uint32_t odp_packet_l2_offset(odp_packet_t pkt);

@@ -514,7 +515,8 @@ void *odp_packet_l3_ptr(odp_packet_t pkt, uint32_t *len);
  *
  * @param pkt  Packet handle
  *
- * @return  Layer 3 start offset or ODP_PACKET_OFFSET_INVALID if not found
+ * @return  Layer 3 start offset
+ * @retval  ODP_PACKET_OFFSET_INVALID  If not found
  */
 uint32_t odp_packet_l3_offset(odp_packet_t pkt);

@@ -560,7 +562,8 @@ void *odp_packet_l4_ptr(odp_packet_t pkt, uint32_t *len);
  *
  * @param pkt  Packet handle
  *
- * @return  Layer 4 start offset or ODP_PACKET_OFFSET_INVALID if not found
+ * @return  Layer 4 start offset
+ * @retval  ODP_PACKET_OFFSET_INVALID  If not found
  */
 uint32_t odp_packet_l4_offset(odp_packet_t pkt);

diff --git a/platform/linux-generic/include/api/odp_platform_types.h b/platform/linux-generic/include/api/odp_platform_types.h
index 2cfba87..8671b42 100644
--- a/platform/linux-generic/include/api/odp_platform_types.h
+++ b/platform/linux-generic/include/api/odp_platform_types.h
@@ -47,6 +47,9 @@ typedef odp_buffer_t odp_packet_t;
 /** Invalid packet */
 #define ODP_PACKET_INVALID ODP_BUFFER_INVALID

+/** Invalid packet offset */
+#define ODP_PACKET_OFFSET_INVALID (0xffffffff)
+
 /** ODP packet segment */
 typedef odp_buffer_t odp_packet_seg_t;

diff --git a/platform/linux-generic/include/odp_packet_internal.h b/platform/linux-generic/include/odp_packet_internal.h
index a0eff30..515c127 100644
--- a/platform/linux-generic/include/odp_packet_internal.h
+++ b/platform/linux-generic/include/odp_packet_internal.h
@@ -169,6 +169,12 @@ static inline void packet_init(pool_entry_t *pool,
 	len = sizeof(odp_packet_hdr_t) - start_offset;
 	memset(start, 0, len);

+	/* Set metadata items that initialize to non-zero values */
+	pkt_hdr->l2_offset = ODP_PACKET_OFFSET_INVALID;
+	pkt_hdr->l3_offset = ODP_PACKET_OFFSET_INVALID;
+	pkt_hdr->l4_offset = ODP_PACKET_OFFSET_INVALID;
+	pkt_hdr->payload_offset = ODP_PACKET_OFFSET_INVALID;
+
        /*
 	* Packet headroom is set from the pool's headroom
 	* Packet tailroom is rounded up to fill the last
@@ -192,15 +198,23 @@ static inline void *packet_map(odp_packet_hdr_t *pkt_hdr,
 			  pkt_hdr->headroom + pkt_hdr->frame_len);
 }

-#define pull_offset(x, len) (x = x < len ? 0 : x - len)
+#define pull_offset(x, len) do { \
+	if (x != ODP_PACKET_OFFSET_INVALID) \
+		x = x < len ? ODP_PACKET_OFFSET_INVALID : x - len; \
+	} while (0)
+
+#define push_offset(x, len) do { \
+	if (x != ODP_PACKET_OFFSET_INVALID) \
+		x += len; \
+	} while (0)

 static inline void push_head(odp_packet_hdr_t *pkt_hdr, size_t len)
 {
 	pkt_hdr->headroom  -= len;
 	pkt_hdr->frame_len += len;
-	pkt_hdr->l2_offset += len;
-	pkt_hdr->l3_offset += len;
-	pkt_hdr->l4_offset += len;
+	push_offset(pkt_hdr->l2_offset, len);
+	push_offset(pkt_hdr->l3_offset, len);
+	push_offset(pkt_hdr->l4_offset, len);
 }

 static inline void pull_head(odp_packet_hdr_t *pkt_hdr, size_t len)
diff --git a/platform/linux-generic/odp_packet.c b/platform/linux-generic/odp_packet.c
index 0ab9866..65e6288 100644
--- a/platform/linux-generic/odp_packet.c
+++ b/platform/linux-generic/odp_packet.c
@@ -776,10 +776,10 @@ int _odp_packet_parse(odp_packet_t pkt)
 	pkt_hdr->error_flags.all  = 0;
 	pkt_hdr->input_flags.all  = 0;
 	pkt_hdr->output_flags.all = 0;
-	pkt_hdr->l2_offset        = 0;
-	pkt_hdr->l3_offset        = 0;
-	pkt_hdr->l4_offset        = 0;
-	pkt_hdr->payload_offset   = 0;
+	pkt_hdr->l2_offset        = ODP_PACKET_OFFSET_INVALID;
+	pkt_hdr->l3_offset        = ODP_PACKET_OFFSET_INVALID;
+	pkt_hdr->l4_offset        = ODP_PACKET_OFFSET_INVALID;
+	pkt_hdr->payload_offset   = ODP_PACKET_OFFSET_INVALID;
 	pkt_hdr->vlan_s_tag       = 0;
 	pkt_hdr->vlan_c_tag       = 0;
 	pkt_hdr->l3_protocol      = 0;
@@ -861,6 +861,7 @@ int _odp_packet_parse(odp_packet_t pkt)

 	default:
 		pkt_hdr->input_flags.l3 = 0;
+		pkt_hdr->l3_offset = ODP_PACKET_OFFSET_INVALID;
 		ip_proto = 255;  /* Reserved invalid by IANA */
 	}

@@ -892,6 +893,7 @@ int _odp_packet_parse(odp_packet_t pkt)

 	default:
 		pkt_hdr->input_flags.l4 = 0;
+		pkt_hdr->l4_offset = ODP_PACKET_OFFSET_INVALID;
 		break;
 	}